/*************************************************
* Basic Filters Header File                      *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_BASIC_FILTERS_H__
#define OPENCL_BASIC_FILTERS_H__

#include <opencl/filter.h>

namespace OpenCL {

/*************************************************
* Fork                                           *
*************************************************/
struct Fork : public Filter
   {
   void write(const byte input[], u32bit length) { send(input, length); }
   void set_port(u32bit n) { set_port(n); }

   Fork(Filter*, Filter*, Filter* = 0, Filter* = 0);
   Fork(Filter*[], u32bit);
   };

/*************************************************
* Chain                                          *
*************************************************/
struct Chain : public Filter
   {
   void write(const byte input[], u32bit length) { send(input, length); }

   Chain(Filter* = 0, Filter* = 0, Filter* = 0, Filter* = 0);
   Chain(Filter*[], u32bit);
   };

}

#endif
