/*************************************************
* Allocator Factory Source File                  *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/secalloc.h>

namespace {

std::string default_allocator = "default";

}

namespace OpenCL {

/*************************************************
* Get an allocator                               *
*************************************************/
SecureAllocator* get_allocator(const std::string& allocator)
   {
   if(allocator == "default") return new DefaultAllocator;
   if(allocator == "lock_memory") return 0;
   if(allocator == "mmap_disk") return 0;
   return get_allocator(default_allocator);
   }

/*************************************************
* Set the default allocator type                 *
*************************************************/
void set_default_allocator(const std::string& alloc)
   {
   if(alloc == "default" || alloc == "lock_memory" || alloc == "mmap_disk")
      default_allocator = alloc;
   }

}
